"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var utilities_1 = require("../../utilities");
var Box = function (_a) {
    var _b;
    var _c = _a.as, Component = _c === void 0 ? 'div' : _c, className = _a.className, align = _a.align, alignItems = _a.alignItems, alignSelf = _a.alignSelf, bg = _a.bg, border = _a.border, borderTop = _a.borderTop, borderEnd = _a.borderEnd, borderBottom = _a.borderBottom, borderStart = _a.borderStart, borderColor = _a.borderColor, borderWidth = _a.borderWidth, color = _a.color, display = _a.display, flexDirection = _a.flexDirection, fs = _a.fs, gradient = _a.gradient, height = _a.height, invisible = _a.invisible, justifyContent = _a.justifyContent, m = _a.m, mt = _a.mt, mb = _a.mb, ms = _a.ms, me = _a.me, mx = _a.mx, my = _a.my, opacity = _a.opacity, overflow = _a.overflow, p = _a.p, pt = _a.pt, pb = _a.pb, ps = _a.ps, pe = _a.pe, px = _a.px, py = _a.py, pointerEvents = _a.pointerEvents, radius = _a.radius, textWrap = _a.textWrap, textNoWrap = _a.textNoWrap, textTransform = _a.textTransform, userSelect = _a.userSelect, visible = _a.visible, width = _a.width, wordBreak = _a.wordBreak, props = __rest(_a, ["as", "className", "align", "alignItems", "alignSelf", "bg", "border", "borderTop", "borderEnd", "borderBottom", "borderStart", "borderColor", "borderWidth", "color", "display", "flexDirection", "fs", "gradient", "height", "invisible", "justifyContent", "m", "mt", "mb", "ms", "me", "mx", "my", "opacity", "overflow", "p", "pt", "pb", "ps", "pe", "px", "py", "pointerEvents", "radius", "textWrap", "textNoWrap", "textTransform", "userSelect", "visible", "width", "wordBreak"]);
    var classNames = (0, classnames_1.default)((_b = {},
        _b["align-".concat(align)] = align,
        _b["bg-".concat(bg)] = bg,
        _b['bg-gradient'] = gradient,
        _b.border = border,
        _b['border-top'] = borderTop === true,
        _b['border-top-0'] = borderTop === 0,
        _b['border-end'] = borderEnd === true,
        _b['border-end-0'] = borderEnd === 0,
        _b['border-bottom'] = borderBottom === true,
        _b['border-bottom-0'] = borderBottom === 0,
        _b['border-start'] = borderStart === true,
        _b['border-start-0'] = borderStart === 0,
        _b["border-".concat(borderColor)] = borderColor,
        _b["border-".concat(borderWidth)] = borderWidth,
        _b["invisible"] = invisible,
        _b["h-".concat(height)] = height,
        _b["fs-".concat(fs)] = fs,
        _b["opacity-".concat(opacity)] = opacity,
        _b["overflow-".concat(overflow)] = overflow,
        _b["pe-".concat(pointerEvents)] = pointerEvents,
        _b["".concat(radius)] = radius,
        _b["text-".concat(color)] = color,
        _b['text-wrap'] = textWrap,
        _b['text-nowrap'] = textNoWrap,
        _b["user-select-".concat(userSelect)] = userSelect,
        _b["visible"] = visible,
        _b["w-".concat(width)] = width,
        _b['text-break'] = wordBreak,
        _b["text-".concat(textTransform)] = textTransform,
        _b), (0, utilities_1.generateResponsiveClasses)('align-items', alignItems), (0, utilities_1.generateResponsiveClasses)('align-self', alignSelf), (0, utilities_1.generateResponsiveClasses)('d', display), (0, utilities_1.generateResponsiveClasses)('flex', flexDirection), (0, utilities_1.generateResponsiveClasses)('justify-content', justifyContent), (0, utilities_1.generateResponsiveClasses)('m', m), (0, utilities_1.generateResponsiveClasses)('mt', mt), (0, utilities_1.generateResponsiveClasses)('mb', mb), (0, utilities_1.generateResponsiveClasses)('ms', ms), (0, utilities_1.generateResponsiveClasses)('me', me), (0, utilities_1.generateResponsiveClasses)('mx', mx), (0, utilities_1.generateResponsiveClasses)('my', my), (0, utilities_1.generateResponsiveClasses)('p', p), (0, utilities_1.generateResponsiveClasses)('pt', pt), (0, utilities_1.generateResponsiveClasses)('pb', pb), (0, utilities_1.generateResponsiveClasses)('ps', ps), (0, utilities_1.generateResponsiveClasses)('pe', pe), (0, utilities_1.generateResponsiveClasses)('px', px), (0, utilities_1.generateResponsiveClasses)('py', py), className);
    return react_1.default.createElement(Component, __assign({ className: classNames }, props));
};
exports.default = Box;
